clc
clear

%   Endzeitpunkt
T = 25;

g = 1;

% Rechte Seite 
% u(1) = theta1
% u(2) = theta2
% u(3) = theta1'
% u(4) = theta2'

f = @(t, u) ( [
  u(3);
  u(4);
  (3*g*sin(u(1)) + g*sin(u(1) - 2*u(2)) + 2*(u(4)^2 + u(3)^2*cos(u(1) - u(2)))*sin(u(1) - u(2))) / (-3 + cos(2*(u(1) - u(2))));
  -((2 *(2 * (u(3)^2 + g*cos(u(1))) + u(4)^2 * cos(u(1) - u(2))) * sin(u(1) - u(2))) / (-3 + cos(2 * (u(1) - u(2)))))
] );



% Anfangsbedingung
u0 = [pi/2; 0; 0; 0];
%u0 = [1];

% Zeitschrittweite
dt = 0.05;

% Zeitgitter
grid = 0 : dt : T;

% Lösung
u = u0;

% Speicher
store = zeros(length(u0), length(grid));
store(:, 1) = u0;

for i = 2 : length(grid)
  t = grid(i);
  
  if (false)
    % Euler Verfahren
    u = u + dt * f(t, u);
    %u = u / (1 + 50*dt);
  else
    % Halbschritt-Verfahren
    for k = 1 : length(u0)
      u(k) = u(k) + dt * f(t, u)(k);
    end 
    
    %u(1) = u(1) + dt * f(t, u)(1);
    %u(2) = u(2) + dt * f(t, u)(2);
  end
  % Speichern die Lösung zum Zeichnen
  store(:, i) = u;
end

theta1 = store(1, :);
theta2 = store(2, :);

p1 = [sin(theta1); -cos(theta1)];
p2 = [sin(theta1) + sin(theta2); -(cos(theta1) + cos(theta2))];

for k = 1 : size(p1, 2)  
  plot([0, p1(1,k), p2(1,k)], [0, p1(2,k), p2(2,k)])
  axis([-2 2 -2 2]);
  
  k_ = max(1, k - 0);
  
  hold on;
  plot(p1(1, k_:k), p1(2, k_:k), 'color', 'red', 'o')
  plot(p2(1, k_:k), p2(2, k_:k), 'color', 'blue', 'o')
  hold off;
  
  pause(0.0);
end

%hold on

%plot(p1(1,:),p1(2,:))
%plot(p2(1,:),p2(2,:))

%axis([-2 2 -2 2])

%plot(p2)

%plot(grid, y, 'LineWidth', 2)
%plot(finegrid, exp(-50.*finegrid))
%plot(grid, v, '--')